/**
 * @author sebastian.fitzner + andy.gutsche
 */
(function($) {
    $.widget('carousel.slideshowAppend', {
        options: {
            textContainer: '.teaser-text'
        },

        _create: function() {
            var that = this;

            this.$slideshow = $(this.element.attr('data-slideshow'));

            if (this.$slideshow.length === 0) {
                return;
            }

            if (this.$slideshow.data('initState') !== 'complete') {
                $(document).one('slideshow.init', this.$slideshow, function() {
                    that._initAppend();
                });
            } else {
                this._initAppend();
            }
        },

        _initAppend: function() {
            var that = this;
            var $slideContent = this.element;
            var $teaserText = this.$slideshow.find(this.options.textContainer);

            $slideContent.append($teaserText.clone());
            $slideContent.children(this.options.textContainer + ':first-child').addClass('active');
            this.slideContent = $slideContent.children(this.options.textContainer);
            this.index = 0;

            this.$slideshow.on('gotoSlide', function(e, i) {
                that.setActive(i);
            });
        },

        setActive: function(i) {
            if (i === this.index) {
                return;
            }

            this.slideContent.removeClass('active');
            $(this.slideContent[i]).addClass('active');
            this.index = i;
        }
    });
})(jQuery);
