/**
 * @author till.reitemeyer + andy.gutsche
 */
(function($) {
    $.widget('carousel.slideshowPager', {
        options: {},

        _create: function() {
            var that = this;
            var $el = this.element;

            this.$slideshow = $(this.element.attr('data-carousel'));

            if (this.$slideshow.length === 0) {
                return;
            }

            if (this.$slideshow.data('initState') !== 'complete') {

                this.$slideshow.on('slideshow.init', function() {

                    that._initPagination();
                });
            } else {
                this._initPagination();
            }
        },

        _initPagination: function() {

            var that = this;
            var $dot = this.element.find('.pagination__list');
            var $dots = this.element.find('.carousel__pagination__wrapper__list');
            var i = 1;

            for (i; i < this.$slideshow.slideshow('getNumSlides'); ++i) {
                $dots.append($dot.clone());
            }

            $dot.addClass('active');
            this.dots = this.element.find('.carousel__pagination__wrapper__list__element');
            this.index = 0;

            this.$slideshow.on('gotoSlide', function(e, i) {
                that.setActive(i);
            });

            this.dots.on('click', function(e) {
                that.$slideshow.slideshow('gotoSlide', $(e.currentTarget).index());
            });
        },


        setActive: function(i) {
            if (i === this.index) {
                return;
            }

            this.dots.removeClass('active');
            $(this.dots[i]).addClass('active');
            this.index = i;
        }
    });
})(jQuery);
